Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.material	(revision 2054)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPEnvMap/GTPEnvMap.material	(revision 2175)
@@ -151,5 +151,5 @@
 			}			
 		 }      
-	     vertex_program_ref GTP/Basic/ShadedTex_VS
+	     vertex_program_ref GTP/Basic/Shaded_VS
      	 {       
             param_named_auto WorldViewProj worldviewproj_matrix 
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPCaustic/GTPCaustic.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPCaustic/GTPCaustic.material	(revision 2136)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPCaustic/GTPCaustic.material	(revision 2175)
@@ -40,9 +40,9 @@
      param_named_auto WorldView     worldview_matrix
      param_named_auto Proj          projection_matrix
-     param_named CauSpriteSize      float 20
+     param_named CauSpriteSize      float 10
    } 
    fragment_program_ref GTP/Caustic/CauCube_PointSprite_PS
    {
-     param_named CausticColor float4          0.7 0.7 0.5 0.3
+     param_named CausticColor float4          1 1 1 0.8
    }
    texture_unit
@@ -120,5 +120,5 @@
 			
 		 }      
-	 vertex_program_ref GTP/Basic/ShadedTex_VS
+	 vertex_program_ref GTP/Basic/Shaded_VS
      	 {       
             param_named_auto WorldViewProj worldviewproj_matrix 
@@ -146,2 +146,60 @@
    }
 }
+
+material GTP/Caustic/Glass_PointSprite
+{
+   technique 
+   {   
+      pass 
+      { 
+		 IllumTechniques
+		 {
+			RenderTechnique ColorCubeMap
+			{
+				update_interval		1
+				update_all_face true									
+			}
+			RenderTechnique DistanceCubeMap
+			{
+				update_interval		1
+				update_all_face true										
+			}
+			RenderTechnique CausticCaster
+			{
+				attenuation	1000
+				update_interval	1
+				update_all_face true
+				photonmap_resolution 64
+				caustic_cubemap_resolution 256
+				photon_map_material	GTP/Caustic/PhotonMap_HitEnv
+				caustic_map_material	GTP/Caustic/CauCube_PointSprite
+				blur_caustic_cubemap false
+			}
+			
+		 }      
+	 vertex_program_ref GTP/Basic/Shaded_VS
+     	 {       
+            param_named_auto WorldViewProj worldviewproj_matrix 
+    	    param_named_auto World world_matrix
+    	    param_named_auto WorldInv inverse_world_matrix
+     	 } 
+	 fragment_program_ref GTP/EnvMap/Localized_Refraction_PS
+     	 { 
+		    param_named_auto cameraPos camera_position
+            param_named lastCenter float3 0 0 0
+            param_named sFresnel float 0.1
+            param_named sRefraction float 0.9
+	     }		
+	     //Cube map for reflections and refractions	
+	     texture_unit
+	     {
+	    
+	     }
+	     //Cube map of distances
+	     texture_unit
+	     {
+	   
+	     }
+	  }
+   }
+}
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection.hlsl	(revision 2131)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection.hlsl	(revision 2175)
@@ -10,11 +10,19 @@
 	return dist;
 }
+
+
 
 #define MAX_LIN_ITERATIONCOUNT 50  //80
 #define MIN_LIN_ITERATIONCOUNT 30  //60
 #define SECANT_ITERATIONCOUNT 1
-#define MAX_RAY_DEPTH 2
-
-void linearSearch(  float3 x, float3 R, float3 N, samplerCUBE mp,
+#define MAX_RAY_DEPTH 4
+
+uniform samplerCUBE mp3Color : register(s0);
+uniform samplerCUBE mp3Dist : register(s1);
+uniform samplerCUBE mp1 : register(s2);
+uniform samplerCUBE mp2 : register(s3);
+							
+
+void linearSearch(  float3 x, float3 R, samplerCUBE mp,
                     out float3 p,
                     out float dl,
@@ -22,51 +30,42 @@
                     out float llp,
                     out float ppp)
-{
- float3 Ra = abs(R), xa = abs(x);
- float xm =  max(max(xa.x,xa.y),xa.z);
- float Rm = max(max(Ra.x,Ra.y),Ra.z);
- float a = xm / Rm;
+{	
+	p = 1;
+	
+ 	float3 Ra = abs(R), xa = abs(x);
+ 	float  a = max(max(xa.x, xa.y), xa.z) / max(max(Ra.x, Ra.y), Ra.z); 
+	bool   undershoot = false, overshoot = false;	
+	
+	float dt =  length(x / max(max(xa.x, xa.y), xa.z) - R / max(max(Ra.x, Ra.y), Ra.z)) * MAX_LIN_ITERATIONCOUNT;
+    dt = max(dt, MIN_LIN_ITERATIONCOUNT);
+    dt = 1.0 / dt;
  
- int shootL = 0, shootP = 0;          
- bool found = false; 
- 
- float dt =  length(x / xm - R / Rm) * MAX_LIN_ITERATIONCOUNT;
- dt = max(dt, MIN_LIN_ITERATIONCOUNT);
- dt = 1.0 / dt;
-    
- float t = 0.01;//dt;
- float pa;
- 
- //Linear iteration
- while(t <= 1.0 && !found)
- {
-   dp = a * t / (1 - t);
-   p = x + R * dp;
-   pa = readDistanceCubeMap(mp, p);
-      
-   if(pa > 0)
-   {
-    ppp = length(p) / pa;
-    if(ppp < 1)
-      shootP = -1;
-    else 
-      shootP = 1;      
-    if(shootL * shootP == -1)
-      found = true;
-    else
-    {
-      shootL = shootP;
-      dl = dp;
-      llp = ppp;
-    }
-   }
-   else
-     shootL = 0;
-      
-   t += dt;  
- }
-
- if(!found)
-  p = float3(0,0,0);
+	float t = 0.01;
+	while( t < 1 && !(overshoot && undershoot) ) {  // iteration 
+		float dr = a * t / (1 - t);  	// ray parameter corresponding to t
+	  	float3 r = x + R * dr;        	// point on the ray
+	  	float ra =  readDistanceCubeMap(mp, r); 	// |p'|: distance direction of p
+	  	
+	  	
+	  	if (ra > 0) {		// valid texel, i.e. anything is visible
+    		float rrp = length(r)/ra; //|r|/|r'|
+   	 		if (rrp < 1) {     	// undershooting
+      			dl = dr;    	// store last undershooting as l
+      			llp = rrp;
+      			undershoot = true;
+    		} else {
+      			dp = dr;    	// store last overshooting as p
+      			ppp = rrp;
+	    		overshoot = true;}
+  		} else {			// nothing is visible: restart search
+    		undershoot = false;	
+    		overshoot = false;
+		}	
+	  	t += dt;                	// next texel
+	}
+
+
+ 	if(!(overshoot && undershoot))
+  	  p = float3(0,0,0); 
 }
 
@@ -98,17 +97,12 @@
 }
 
-float3 Hit(float3 x, float3 R, float3 N, 
-           samplerCUBE mp1,
-           samplerCUBE mp2,
-           samplerCUBE mp3Color,
-           samplerCUBE mp3Dist,
-           out float4 Il, out float3 Nl)
+float3 Hit(float3 x, float3 R, out float4 Il, out float3 Nl)
 {
  float dl1 = 0, dp1, llp1, ppp1;
  float3 p1;
- linearSearch(x, R, N, mp1, p1, dl1, dp1, llp1, ppp1);
+ linearSearch(x, R, mp1, p1, dl1, dp1, llp1, ppp1);
  float dl2 = 0, dp2, llp2, ppp2;
  float3 p2;
- linearSearch(x, R, N, mp2, p2, dl2, dp2, llp2, ppp2);
+ linearSearch(x, R, mp2, p2, dl2, dp2, llp2, ppp2);
  
  bool valid1 = dot(p1,p1) != 0;
@@ -120,5 +114,5 @@
  if(!valid1 && ! valid2)
  {
-    linearSearch(x, R, N, mp3Dist, p, dl, dp, llp, ppp);
+    linearSearch(x, R, mp3Dist, p, dl, dp, llp, ppp);
     Il.a = 1; 
     secantSearch(x, R, mp3Dist, dl, dp, llp, ppp, p);
@@ -145,4 +139,96 @@
 }
 
+
+
+void SpecularReflectionVS(    	
+	in  float4 Pos  : POSITION, 	// modeling space
+  	in  float4 Norm : NORMAL,		// normal vector
+  	out float4 hPos : POSITION, 	// clipping space
+  	out float3 x    : TEXCOORD1,	// cube map space
+  	out float3 N    : TEXCOORD2,	// normal
+  	out float3 V    : TEXCOORD3, 	// view
+   uniform float4x4 WorldViewProj,  
+   uniform float4x4 World,
+   uniform float4x4 WorldIT,
+   uniform float3   eyePos    // eye position
+) {
+  	hPos = mul(Pos, WorldViewProj);
+  	x    = mul(Pos, World).xyz;
+  	N    = mul(Norm, WorldIT).xyz;
+  	V    = x - eyePos;
+}
+
+float4 SingleReflectionPS( 	
+	float3 x : TEXCOORD1,    	// cube map space
+  	float3 N : TEXCOORD2,    	// normal
+  	float3 V : TEXCOORD3,     	// view
+  	uniform float Fp0,
+  	uniform float3 lastCenter // cube map center position    
+) : COLOR
+{
+	x -= lastCenter;
+  	V = normalize(V); N = normalize(N);
+  	float3 R = reflect(V, N);	// reflection dir.
+  	float3 Nl;   			// normal vector at the hit point
+  	float3 Il;   			// radiance at the hit point
+  	// ray hit l, radiance Il, normal Nl 
+	float3 l = Hit(x, R, Il, Nl);
+
+  	// Fresnel reflection
+  	float3 F = Fp0 + pow(1-dot(N, -V), 5) * (1 - Fp0);
+  	return float4(F * Il, 1);
+}
+
+float4 MultipleReflectionPS( 	
+							float3 x : TEXCOORD1,     	// shaded point in Cube map space
+  							float3 N : TEXCOORD2,     	// normal vector
+  							float3 V : TEXCOORD3,      	// view direction
+							uniform float3 Fp0,  	// Fresnel at perpendicular direction
+							uniform float3 refIndex,   	// index of refraction
+							uniform float3 lastCenter
+) : COLOR
+{
+	x-= lastCenter;
+  	V = normalize(V); N = normalize(N);
+
+  	float3 I = float3(1, 1, 1);// radiance of the path
+  	float3 Fp = Fp0;           // Fresnel at 90 degrees at first hit
+  	float  n = refIndex;             // index of refraction of the first hit
+  	int depth = 0;		// length of the path
+  	while (depth < MAX_RAY_DEPTH) {
+    	float3 R;      	// reflection or refraction dir
+    	float3 F = Fp + pow(1-abs(dot(N, -V)), 5) * (1-Fp);  // Fresnel
+        if (n <= 0) {
+      		R = reflect(V, N);  // reflection
+      		I *= F;             // Fresnel reflection
+    	}
+        else{              	// refraction
+      		if (dot(V,N) > 0) { // coming from inside
+        			n = 1.0 / n;
+        			N = -N;
+      		}
+      		R = refract(V, N, n);
+      		if (dot(R, R) == 0)	// no refraction direction exits
+      			R = reflect(V, N); // total reflection  			
+			else
+     			I *= (1-F);        // Fresnel refraction
+    	}
+    	
+    	float3 Nl;		// normal vector at the hit point
+    	float4 Il;      	// radiance at the hit point
+  		// Trace ray x+R*d and obtain hit l, radiance Il, normal Nl 
+ 	    float3 l = Hit(x, R, Il, Nl);
+ 	    if (Il.a == 0) {    	// hit point is on specular surface
+      		depth += 1;
+    	} else {         	// hit point is on diffuse surface
+      		I *= Il.rgb;	// multiply with the radiance 
+ 		depth = MAX_RAY_DEPTH;   // terminate
+    	}
+    	N = Nl; V = R; x = l; // hit point is the next shaded point
+  	}
+  	return float4(I, 1);
+}
+
+
 struct Shaded_OUT
 {
@@ -152,12 +238,9 @@
 };
 
-float4 MultipleReflectionPS(Shaded_OUT IN,
-							uniform samplerCUBE CubeMap : register(s0),
-							uniform samplerCUBE DistanceMap : register(s1),
-							uniform samplerCUBE NormDistMap1 : register(s2),
-							uniform samplerCUBE NormDistMap2 : register(s3),
+float4 MultipleReflectionPS_o(Shaded_OUT IN,
 							uniform float3 cameraPos,
 							uniform float3 lastCenter) : COLOR0
 {	
+	return 1;
 	 float4 I = float4(0,0,0,0);
 			
@@ -181,5 +264,5 @@
 	   float3 Nl;
 	   float4 Il = 0;
-	   l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, Il, Nl);
+	   l = Hit(x, R, Il, Nl);
 	   if(Il.a == 0)
 	   {	   
@@ -197,5 +280,5 @@
 	}
 	if(I.a == 0)
-	   I = readCubeMap(CubeMap, l);
+	   I = readCubeMap(mp3Color, l);
 	
 	return I;
@@ -203,10 +286,6 @@
 
 float4 MultipleRefractionPS(Shaded_OUT IN,
-							uniform samplerCUBE CubeMap : register(s0),
-							uniform samplerCUBE DistanceMap : register(s1),
-							uniform samplerCUBE NormDistMap1 : register(s2),
-							uniform samplerCUBE NormDistMap2 : register(s3),
 							uniform float3 cameraPos,
-							uniform float3 lastCenter,
+							uniform float3 lastCenter,							
 							uniform float sFresnel,
 							uniform float refIndex ) : COLOR0
@@ -238,5 +317,5 @@
 	  float3 Nl;
 	  float4 Il;
-	  float3 l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, Il, Nl);
+	  float3 l = Hit(x, R, Il, Nl);
 	  if(Il.a == 0)
 	  {		  
@@ -252,5 +331,5 @@
 	  V = R;	   	   
 	} 
-		
+	/*	
 	if(I.a == 0)
 	{
@@ -263,7 +342,7 @@
 	 float3 R = refract( V, N, ri);
 	 if(dot(R,R) == 0) R = reflect( V, N);
-	 I = readCubeMap(CubeMap, R);
+	 I = readCubeMap(mp3Color, R);
  	}
-	
+	*/
 	I *= (1.0 - F);	
     
@@ -272,8 +351,4 @@
 
 float4 MultipleRefractionPhotonMap_PS(Shaded_OUT IN,
-									uniform samplerCUBE DistanceMap  : register(s0),
-									uniform samplerCUBE NormDistMap1 : register(s1),
-									uniform samplerCUBE NormDistMap2 : register(s2),
-									uniform samplerCUBE CubeMap      : register(s3), //NOT USED
 									uniform float3 cameraPos,
 									uniform float3 lastCenter,
@@ -304,5 +379,5 @@
 	  float3 Nl;
 	  float4 Il;
-	  l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, Il, Nl);
+	  l = Hit(x, R, Il, Nl);
 	  if(Il.a == 0)
 	  {
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/multipleRefraction/GTPMultipleRefraction.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/multipleRefraction/GTPMultipleRefraction.material	(revision 2131)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/multipleRefraction/GTPMultipleRefraction.material	(revision 2175)
@@ -1,12 +1,127 @@
-fragment_program GTP/MultiBounce/Refraction_PS hlsl
-{
-	
+vertex_program GTP/MultiBounce/MultiBounce_VS hlsl
+{	
 	source GTPMultipleReflection.hlsl
-    entry_point MultipleRefractionPS
+    entry_point SpecularReflectionVS
+	target vs_3_0	
+}
+
+//fragment_program GTP/MultiBounce/SingleReflection_PS hlsl
+//{	
+//	source GTPMultipleReflection.hlsl
+//    entry_point SingleReflectionPS
+//	target ps_3_0
+//	flow_control prefer
+//}
+
+fragment_program GTP/MultiBounce/MultipleReflection_PS hlsl
+{	
+	source GTPMultipleReflection.hlsl
+   entry_point MultipleReflectionPS
 	target ps_3_0
 	flow_control prefer
 }
 
+
 material GTP/MultiBounce/Refractor
+{ 
+   technique 
+   { 
+      pass 
+      { 
+        //cull_hardware none
+		IllumTechniques
+		{
+			RenderTechnique ColorCubeMap
+			{
+				resolution 1024
+				update_interval		1
+				distance_calc false
+				face_angle_calc false
+				update_all_face true
+								
+			}
+			RenderTechnique DistanceCubeMap
+			{
+				resolution 1024
+				update_interval		1
+				distance_calc false
+				face_angle_calc false
+				update_all_face true				
+			}
+			RenderTechnique ColorCubeMap
+			{
+				resolution 1024
+				layer 1
+				texture_unit_id 2
+				update_interval		1
+				distance_calc false
+				face_angle_calc false
+				update_all_face true
+				render_env false
+				render_self true
+				self_material GTP/MultiBounce/NormalDistanceCCW				
+			}
+			RenderTechnique ColorCubeMap
+			{
+				resolution 1024
+				layer 2
+				texture_unit_id 3
+				update_interval		1
+				distance_calc false
+				face_angle_calc false
+				update_all_face true
+				render_env false
+				render_self true
+				self_material GTP/MultiBounce/NormalDistanceCW			
+			}				
+		 }
+		 vertex_program_ref GTP/MultiBounce/MultiBounce_VS
+    	 {       
+       	 	param_named_auto WorldViewProj transpose_worldviewproj_matrix 
+    		param_named_auto World         transpose_world_matrix
+    		param_named_auto WorldIT inverse_world_matrix
+    		param_named_auto eyePos camera_position			
+   		 }
+		 fragment_program_ref GTP/MultiBounce/MultipleReflection_PS
+         { 
+			param_named refIndex float 0.77
+			param_named Fp0 float 0.1
+		 } 
+		
+		//Cube map of environment
+		texture_unit
+		{
+			//filtering none
+		}
+		//Cube map of environment distances
+		texture_unit
+		{
+			filtering none
+		}
+		
+		//Cube map of reflective object's normals and distances CCW
+		texture_unit
+		{
+			filtering none
+		}		
+		//Cube map of reflective object's normals and distances CW
+		texture_unit
+		{
+			filtering none
+		}
+	  }
+    }
+}
+
+
+//fragment_program GTP/MultiBounce/Refraction_PS hlsl
+//{	
+//	source GTPMultipleReflection.hlsl
+//   entry_point MultipleRefractionPS
+//	target ps_3_0
+//	flow_control prefer
+//}
+
+material GTP/MultiBounce/Refractor_0
 { 
    technique 
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection_good.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection_good.hlsl	(revision 2175)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPAdvancedEnvMap/multibounce/GTPMultipleReflection_good.hlsl	(revision 2175)
@@ -0,0 +1,326 @@
+float4 readCubeMap(samplerCUBE cm, float3 coord)		
+{
+	float4 color = texCUBElod( cm, float4(coord.xy, - coord.z,0) );
+	return color;
+}
+
+float readDistanceCubeMap(samplerCUBE dcm, float3 coord)		
+{
+	float dist = texCUBElod(dcm, float4(coord.xy, - coord.z,0)).a;
+	return dist;
+}
+
+#define MAX_LIN_ITERATIONCOUNT 50  //80
+#define MIN_LIN_ITERATIONCOUNT 30  //60
+#define SECANT_ITERATIONCOUNT 1
+#define MAX_RAY_DEPTH 2
+
+void linearSearch(  float3 x, float3 R, float3 N, samplerCUBE mp,
+                    out float3 p,
+                    out float dl,
+                    out float dp,
+                    out float llp,
+                    out float ppp)
+{
+ float3 Ra = abs(R), xa = abs(x);
+ float xm =  max(max(xa.x,xa.y),xa.z);
+ float Rm = max(max(Ra.x,Ra.y),Ra.z);
+ float a = xm / Rm;
+ 
+ int shootL = 0, shootP = 0;          
+ bool found = false; 
+ 
+ float dt =  length(x / xm - R / Rm) * MAX_LIN_ITERATIONCOUNT;
+ dt = max(dt, MIN_LIN_ITERATIONCOUNT);
+ dt = 1.0 / dt;
+    
+ float t = 0.01;//dt;
+ float pa;
+ 
+ //Linear iteration
+ while(t <= 1.0 && !found)
+ {
+   dp = a * t / (1 - t);
+   p = x + R * dp;
+   pa = readDistanceCubeMap(mp, p);
+      
+   if(pa > 0)
+   {
+    ppp = length(p) / pa;
+    if(ppp < 1)
+      shootP = -1;
+    else 
+      shootP = 1;      
+    if(shootL * shootP == -1)
+      found = true;
+    else
+    {
+      shootL = shootP;
+      dl = dp;
+      llp = ppp;
+    }
+   }
+   else
+     shootL = 0;
+      
+   t += dt;  
+ }
+
+ if(!found)
+  p = float3(0,0,0);
+}
+
+
+void secantSearch(float3 x, float3 R, samplerCUBE mp, 
+	               float dl,
+	               float dp,
+	               float llp,
+	               float ppp,
+	               out float3 p)
+{
+  for(int i= 0; i < SECANT_ITERATIONCOUNT; i++)
+  {
+   float dnew;
+   dnew = dl + (dp - dl) * (1 - llp) / (ppp - llp);
+   p = x + R * dnew;
+   half pppnew = length(p) / readDistanceCubeMap(mp, p);
+   if(pppnew < 1)
+   {
+    llp = pppnew;
+    dl = dnew;
+   }
+   else
+   {
+    ppp = pppnew;
+    dp = dnew;
+   }
+  }
+}
+
+float3 Hit(float3 x, float3 R, float3 N, 
+           samplerCUBE mp1,
+           samplerCUBE mp2,
+           samplerCUBE mp3Color,
+           samplerCUBE mp3Dist,
+           out float4 Il, out float3 Nl)
+{
+ float dl1 = 0, dp1, llp1, ppp1;
+ float3 p1;
+ linearSearch(x, R, N, mp1, p1, dl1, dp1, llp1, ppp1);
+ float dl2 = 0, dp2, llp2, ppp2;
+ float3 p2;
+ linearSearch(x, R, N, mp2, p2, dl2, dp2, llp2, ppp2);
+ 
+ bool valid1 = dot(p1,p1) != 0;
+ bool valid2 = dot(p2,p2) != 0;
+		
+ float dl, dp, llp, ppp;
+ float3 p;
+ 
+ if(!valid1 && ! valid2)
+ {
+    linearSearch(x, R, N, mp3Dist, p, dl, dp, llp, ppp);
+    Il.a = 1; 
+    secantSearch(x, R, mp3Dist, dl, dp, llp, ppp, p);
+    Il.rgb =  Nl.rgb = readCubeMap(mp3Color, p).rgb;  
+ }
+ else
+ {
+    if( !valid2 || (valid1 && dp1 < dp2))
+    {
+     secantSearch(x, R, mp1, dl1, dp1, llp1, ppp1, p1);
+     Il.rgb =  Nl.rgb = readCubeMap(mp1, p1).rgb;
+     p = p1;
+    }
+    else
+    {
+     secantSearch(x, R, mp2, dl2, dp2, llp2, ppp2, p2);
+     Il.rgb =  Nl.rgb = readCubeMap(mp2, p2).rgb;
+     p = p2;
+    }
+    Il.a = 0;   
+ }
+ 
+ return p;
+}
+
+struct Shaded_OUT
+{
+ float4 vPos : POSITION;
+ float4 wNormal : TEXCOORD0;
+ float4 wPos    : TEXCOORD1; 
+};
+
+float4 MultipleReflectionPS(Shaded_OUT IN,
+							uniform samplerCUBE CubeMap : register(s0),
+							uniform samplerCUBE DistanceMap : register(s1),
+							uniform samplerCUBE NormDistMap1 : register(s2),
+							uniform samplerCUBE NormDistMap2 : register(s3),
+							uniform float3 cameraPos,
+							uniform float3 lastCenter) : COLOR0
+{	
+	 float4 I = float4(0,0,0,0);
+			
+	 float3 N = normalize(IN.wNormal.xyz);
+	 float3 x = IN.wPos.xyz - lastCenter;
+	 float3 V  = (IN.wPos.xyz - cameraPos);
+	 
+	 V = normalize(V);
+	 float3 l;
+
+		
+	//return readCubeMap(NormDistMap2, x).a /2.0 + 0.000000000001 * x.x;
+	  
+	 int depth = 0;
+	
+	 while(depth < MAX_RAY_DEPTH)
+	 {
+	   float3 R;  
+	   R = normalize(reflect( V, N));	  
+	  	
+	   float3 Nl;
+	   float4 Il = 0;
+	   l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, Il, Nl);
+	   if(Il.a == 0)
+	   {	   
+		  depth += 1;		 
+	   }
+	   else
+	   {
+		   I = Il;
+		   depth = MAX_RAY_DEPTH;
+	   }
+	   x = l;	   
+	   N = Nl;
+	   V = R;   
+	   
+	}
+	if(I.a == 0)
+	   I = readCubeMap(CubeMap, l);
+	
+	return I;
+}
+
+float4 MultipleRefractionPS(Shaded_OUT IN,
+							uniform samplerCUBE CubeMap : register(s0),
+							uniform samplerCUBE DistanceMap : register(s1),
+							uniform samplerCUBE NormDistMap1 : register(s2),
+							uniform samplerCUBE NormDistMap2 : register(s3),
+							uniform float3 cameraPos,
+							uniform float3 lastCenter,
+							uniform float sFresnel,
+							uniform float refIndex ) : COLOR0
+{
+	 float4 I = float4(0,0,0,0);
+			
+	 float3 N = normalize(IN.wNormal.xyz);
+	 float3 x = IN.wPos.xyz - lastCenter;
+	 float3 V  = (IN.wPos.xyz - cameraPos);
+	  V = normalize(V);
+	 
+	 float F;
+	 int depth = 0;
+	F = sFresnel + pow(1 - dot(N, -V), 5) * (1 - sFresnel);	 
+	
+	while(depth < MAX_RAY_DEPTH)
+	{
+	  float3 R;  
+	  	 
+	  float ri = refIndex;	 
+	  if(dot(V,N) > 0)
+	  {
+		ri = 1.0 / ri;
+		N = -N;	    
+	  }
+	  R = refract( V, N, ri);
+	  if(dot(R,R) == 0) R = reflect( V, N);
+	  					
+	  float3 Nl;
+	  float4 Il;
+	  float3 l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, Il, Nl);
+	  if(Il.a == 0)
+	  {		  
+		   depth += 1;		 
+	  }
+	  else
+	  {
+		   I = Il;
+		   depth = MAX_RAY_DEPTH;
+	  }
+	  x = l;	   
+	  N = normalize(Nl);
+	  V = R;	   	   
+	} 
+		
+	if(I.a == 0)
+	{
+	 float ri = refIndex;	 
+	 if(dot(V,N) > 0)
+	 {
+		ri = 1.0 / ri;
+		N = -N;	    
+	 }
+	 float3 R = refract( V, N, ri);
+	 if(dot(R,R) == 0) R = reflect( V, N);
+	 I = readCubeMap(CubeMap, R);
+ 	}
+	
+	I *= (1.0 - F);	
+    
+	return I;
+}
+
+float4 MultipleRefractionPhotonMap_PS(Shaded_OUT IN,
+									uniform samplerCUBE DistanceMap  : register(s0),
+									uniform samplerCUBE NormDistMap1 : register(s1),
+									uniform samplerCUBE NormDistMap2 : register(s2),
+									uniform samplerCUBE CubeMap      : register(s3), //NOT USED
+									uniform float3 cameraPos,
+									uniform float3 lastCenter,
+									uniform float refIndex) : COLOR0
+{
+	 float4 I = 0;		
+	 float3 N = normalize(IN.wNormal.xyz);
+	 float3 x = IN.wPos.xyz - lastCenter;
+	 float3 V  = (IN.wPos.xyz - cameraPos);
+	 V = normalize(V);
+	 
+	int depth = 0;
+	float3 l;
+	
+	while(depth < MAX_RAY_DEPTH)
+	{
+	  float3 R;  
+	  	 
+	  float ri = refIndex;	 
+	  if(dot(V,N) > 0)
+	  {
+		ri = 1.0 / ri;
+		N = -N;	    
+	  }
+	  R = refract( V, N, ri);
+	  if(dot(R,R) == 0) R = reflect( V, N);
+	  					
+	  float3 Nl;
+	  float4 Il;
+	  l = Hit(x, R, N, NormDistMap1, NormDistMap2, CubeMap, DistanceMap, Il, Nl);
+	  if(Il.a == 0)
+	  {
+		  depth += 1;		 
+	  }
+	  else
+	  {
+		  I = Il;
+		  depth = MAX_RAY_DEPTH;
+	  }
+	  x = l;	   
+	  N = normalize(Nl);
+	  V = R;	   	   
+	}  
+	if(I.a == 0)
+		I = float4(V,1);
+	else
+		I = float4(l,1);
+	
+	return I;
+}
Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material	(revision 2139)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/difflab.material	(revision 2175)
@@ -116,8 +116,8 @@
 		    {
 			
-			 RenderTechnique CausticReciever
-			 {
-				max_caster_count	1					
-			 }
+			// RenderTechnique CausticReciever
+			// {
+			//	max_caster_count	1					
+			// }
 			 RenderTechnique DepthShadowReciever
 			 {
@@ -147,8 +147,8 @@
 		    {
 			
-			 RenderTechnique CausticReciever
-			 {
-				max_caster_count	1					
-			 }
+			// RenderTechnique CausticReciever
+			// {
+			//	max_caster_count	1					
+			// }
 			 RenderTechnique DepthShadowReciever
 			 {
@@ -199,8 +199,8 @@
 		{
 			
-			RenderTechnique CausticReciever
-			{
-				max_caster_count	1					
-			}
+			//RenderTechnique CausticReciever
+			//{
+			//	max_caster_count	1					
+			//}
 			RenderTechnique DepthShadowReciever
 			{
@@ -237,8 +237,8 @@
 		{
 			
-			RenderTechnique CausticReciever
-			{
-				max_caster_count	1					
-			}
+			//RenderTechnique CausticReciever
+			//{
+			//	max_caster_count	1					
+			//}
 			RenderTechnique DepthShadowReciever
 			{
@@ -293,8 +293,8 @@
 		{
 			
-			RenderTechnique CausticReciever
-			{
-				max_caster_count	1					
-			}
+			//RenderTechnique CausticReciever
+			//{
+			//	max_caster_count	1					
+			//}
 			RenderTechnique DepthShadowReciever
 			{
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 2125)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 2175)
@@ -130,4 +130,9 @@
 	}
     
+	void chooseSceneManager()
+	{
+		//mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
+	}
 
 	void createScene(void)
@@ -218,8 +223,8 @@
 		mFrameListener= new ParticleDemoFrameListener(mWindow,
 											mCamera	);
-		mFrameListener->setPriority(1);
-		OgreIlluminationManager::getSingleton().setPriority(2);
-    mRoot->addFrameListener(mFrameListener);
-	mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
+		mFrameListener->setPriority(2);
+		OgreIlluminationManager::getSingleton().setPriority(3);
+		mRoot->addFrameListener(mFrameListener);
+		mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
    }
 
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/include/GameToolsToneMapDemo.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/include/GameToolsToneMapDemo.h	(revision 2025)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsToneMapDemo/include/GameToolsToneMapDemo.h	(revision 2175)
@@ -69,4 +69,10 @@
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("General");
 		ResourceGroupManager::getSingleton().initialiseResourceGroup("PostProc");
+	}
+
+	void chooseSceneManager()
+	{
+		mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
 	}
 
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h	(revision 2025)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h	(revision 2175)
@@ -95,11 +95,14 @@
 	}
     
-	 virtual void chooseSceneManager(void)
-    {
+	void chooseSceneManager()
+	{
 		if(scene == 1)
-		 ExampleApplication::chooseSceneManager();
+		{
+		  mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		  //mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
+		}
 		else if(scene == 2)
-         mSceneMgr = mRoot->createSceneManager("TerrainSceneManager");
-    }
+           mSceneMgr = mRoot->createSceneManager("TerrainSceneManager");
+	}
 
 	void createScene(void)
@@ -200,6 +203,6 @@
 		mFrameListener= new ParticleDemoFrameListener(mWindow,
 											mCamera	, mainLightNode);
-       mFrameListener->setPriority(1);
-		OgreIlluminationManager::getSingleton().setPriority(2);
+       mFrameListener->setPriority(2);
+		OgreIlluminationManager::getSingleton().setPriority(10);
 		 mRoot->addFrameListener(mFrameListener);
 		 mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h	(revision 2167)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h	(revision 2175)
@@ -85,5 +85,5 @@
 														"GTP/PostProc/ToneMap");
 		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
-														"GTP/PostProc/ToneMap", true);		
+														"GTP/PostProc/ToneMap", true);	
 	}
     
@@ -91,9 +91,10 @@
 	{
 		mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
 	}
 
 	void createScene(void)
     {
-		//createPostproc();
+		createPostproc();
 
 		OgreIlluminationManager::getSingleton().setMainCamera(mCamera);
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 2057)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/DiffuseTest/include/DiffuseTest.h	(revision 2175)
@@ -375,4 +375,10 @@
 		CompositorManager::getSingleton().setCompositorEnabled(mWindow->getViewport(0),
 														"GTP/PostProc/ToneMap", true);		
+	}
+
+	void chooseSceneManager()
+	{
+		mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
 	}
     
